
import particles
import couplings
import lorentz
import parameters
import vertices
import coupling_orders
#import write_param_card
import propagators
import object_library
import function_library


all_particles = particles.all_particles
all_vertices = vertices.all_vertices
all_couplings = couplings.all_couplings
all_lorentz = lorentz.all_lorentz
all_parameters = parameters.all_parameters
all_orders = coupling_orders.all_orders
all_functions = function_library.all_functions
all_propagators = propagators.all_propagators

try:
   import decays
except ImportError:
   pass
else:
   all_decays = decays.all_decays

try:
   import form_factors
except ImportError:
   pass
else:
   all_form_factors = form_factors.all_form_factors

try:
   import CT_vertices
except ImportError:
   pass
else:
   all_CTvertices = CT_vertices.all_CTvertices


gauge = [0, 1]


__author__ = "Gauthier Durieux"
__email__ = "gauthier.durieux@cern.ch"
__arxiv__ = "[1107.3805], PRD85(2012)016006"
__date__ = "2022-01-21"
__version__= "1.1"
